package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10070MHQResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10070MHQSendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10070MHQLogin extends ProtBase{


	private final short iTaskCode10070 = 10070;
	private Gson gson;
	private Prot10070MHQResult resMsgBean;
	public Prot10070MHQLogin() {
		gson = new Gson();

	}
	
	public Prot10070MHQResult getResMsgBean() {
		return resMsgBean;
	}

	public void setResMsgBean(Prot10070MHQResult resMsgBean) {
		this.resMsgBean = resMsgBean;
	}

	public void dealLoginMHQ(SocketCreate create,
                             Prot10070MHQSendBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10070MHQSendBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10070, "开始请求产品列表激活协议");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10070MHQSendBean labelBean)
			throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10070, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10070, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10070, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resMsgBean = gson.fromJson(jsonData, Prot10070MHQResult.class);
		}
		recCheckCode(dis);
	}
}
